from sqlalchemy import Identity
from sqlalchemy.orm import Mapped, mapped_column

from db.models.base import Base


class LoadParameters(Base):
    __tablename__ = 'load_parameters'

    id: Mapped[int] = mapped_column(Identity(start=1000, cycle=True),
                                    primary_key=True)
    load: Mapped[int]
    primary_air_consumption: Mapped[float]
    secondary_air_consumption: Mapped[float]
    gas_inlet_consumption: Mapped[float]

    def __repr__(self):
        return f"<LoadParameters>"
