from sqlalchemy.ext.asyncio import create_async_engine, async_sessionmaker
from settings import settings

engine_postgres = create_async_engine(url=settings.db_url_asyncpg_docker, echo=True)
async_session_postgres = async_sessionmaker(engine_postgres, expire_on_commit=False)


# Функция для получения новой сессии
async def get_async_session():
    async with async_session_postgres() as session:
        yield session