from typing import Sequence

from sqlalchemy import update, delete
from sqlalchemy.ext.asyncio import AsyncSession
from sqlalchemy.future import select
from typing_extensions import deprecated
from db.models import ExperimentCategory


@deprecated(
    "теперь есть параметризованный круд, а уже свои специфичные методы у каждой сущности в своем репозитории"
)
class ExperimentCategoryRepository:
    def __init__(self, session: AsyncSession):
        self.session = session

    async def get_all(self) -> Sequence[ExperimentCategory]:
        result = await self.session.execute(select(ExperimentCategory))
        return result.scalars().all()

    async def get_by_id(self, id: int) -> ExperimentCategory:
        result = await self.session.execute(select(ExperimentCategory).where(ExperimentCategory.id == id))
        return result.scalar_one_or_none()

    async def create(self, new_data: ExperimentCategory):
        self.session.add(new_data)
        await self.session.commit()

    async def update(self, id: int, updated_data: dict):
        stmt = (
            update(ExperimentCategory).
            where(ExperimentCategory.id == id).
            values(**updated_data)
        )
        await self.session.execute(stmt)
        await self.session.commit()

    async def delete(self, id: int):
        stmt = delete(ExperimentCategory).where(ExperimentCategory.id == id)
        await self.session.execute(stmt)
        await self.session.commit()